Subject: Re: bug#68686: [Bug] smtpmail-send-queued-mail ignores some headers of the message it's sending!

From: Manuel Giraud <[email-masked]>
Date: Wed, 24 Jan 2024 17:01:22 +0100

[email-masked] writes:

> Disclaimer: I use Rmail on Emacs, and Message-Mode.
>
> Bug Part 1:
>
> The From: header is ignored (from the message as saved in 'queued
> email folder') when sending with smtpmail-send-queued-mail, and takes
> the value of user-mail-address when this wasn't previously customized
> by the user. This is really worrisome! What else is ignored and
> rewritten without warning when invoking smtpmail-send-queued-mail?

This is not what I observe.  Like you, I have a one word (without dot)
hostname: "computer".  Then, I do:

   - emacs -Q
   - M-: (setq send-mail-function 'smtpmail-send-it)
   - M-: (setq smtpmail-queue-mail t)
   - M-x message-mail
  [ here the "From:" is set to
    [email-masked]]
   - I fill "To:" and 'C-c C-c'
  [ now another mail… ]
   - M-x message-mail
  [ I fill "To:" and change the "From:" to manuel@elsewhere ]
   - 'C-c C-c'
  [ do send now… ]
   - M-x smtpmail-send-queued-mail

Both mails are sent and when I retrieve them both have the "From:"
exactly how it was: respectively
[email-masked] and manuel@elsewhere

> Followup to Bug Part 1:
>
> It would be interesting to figure out whether this happens also when
> user-mail-address had been previously customized by the user.
>
> Bug Part 2:
>
> This discrepancy between the behaviour of queued-sending and immediate
> sending (I use the default functions for the most current version of
> Emacs as of today) I consider to be a bug on itself. Because not doing
> things consistently confuses the user (even not doing the *wrong*
> thing consistently confuses the user. In this case the wrong thing is
> rewriting the From: header of every email).

I have tested the same recipe as above (without setting
smtpmail-queue-mail to t) and it works correctly for me and the "From:"
of the two retrieved mails are also the same.  Could you test this
recipe?
-- 
Manuel Giraud